<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>reto clase 7</title>
</head>

<body>
    <div id="contenedor"> </div>

    <script type="text/javascript">

        //LISTAS PARA ALMACENAR LOS DATOS DE LOS PERROS
        let mostradorDeNombresPerros = "LISTA DE PERROS:\n\n";
        let mostradorDeDatosPerros = "LISTA DE PERROS:\n\n";
        let mostradorDeEstado = "";

        //LISTAS PARA SEGMENTAR LOS PERROS
        let perrosDisponibles = "\n\nLISTA DE PERROS DISPONIBLES PARA LA ADOPCIÓN: \n";
        let perrosEnProceso = "LISTA DE PERROS EN PROCESO DE ADOPCIÓN:\n ";
        let perrosAdoptados = "LISTA DE PERROS YA ADOPTADOS: \n\n";

        class Perro {
            constructor(nombre, color, raza, edad, vacunado, estado) {
                this.nombre = nombre;
                this.color = color;
                this.raza = raza;
                this.edad = edad;

                //CAMBIANDO EL TRUE/FALSE POR UN SI O NO
                if (vacunado === true) {
                    vacunado = "Si";
                } else {
                    vacunado = "No";
                }

                this.vacunado = vacunado;

                //AUXILIAR MOSTRAR TEXTO DESDE EL INICIO DEL CODIGO
                this.estado_aux = estado;
                switch (estado) {
                    case 1:
                        estado = "En adopción";
                        break;

                    case 2:
                        estado = "Proceso de adopción";
                        break;

                    case 3:
                        estado = "Adoptado";
                        break;
                }

                this.estado = estado;
            }

            modificarAdoptado(aux) {
                switch (aux) {
                    case 1:
                        this.estado = "En adopción";
                        break;

                    case 2:
                        this.estado = "Proceso de adopción";
                        break;

                    case 3:
                        this.estado = "Adoptado";
                        break;
                }
            }

            mostrarDatos() {
                let mostrador = ` Nombre del Perro:${this.nombre} \n Color del Perro:${this.color} \n Raza del Perro:${this.raza} \n Edad del Perro:${this.edad} \n Esta vacunado:${this.vacunado} \n Estado del Perro:${this.estado} \n`;
                return mostrador;
            }

            mostrarNombres() {
                let mostrador = ` Nombre del Perro:${this.nombre} \n`;
                return mostrador;
            }

            verificarEstado() {
                if (this.estado_aux == 1) {
                    perrosDisponibles = `${perrosDisponibles}  \n\n  ${this.nombre}`;
                } else if (this.estado_aux == 2) {
                    perrosEnProceso = `${perrosEnProceso}  \n\n  ${this.nombre}`
                } else if (this.estado_aux == 3) {
                    perrosAdoptados = `${perrosAdoptados}  \n\n  ${this.nombre}`
                }
            }
        }



        let perros = [];

        //FUNCION PARA CREAR LOS PERROS Y ALMACENARLOS EN EL ARRAY
        const introducirPerro = (nombre, color, raza, edad, vacunado, estado) => {
            for (let i = 0; i <= perros.length; i++) {
                if (perros[i] === undefined) {
                    perros[i] = new Perro(nombre, color, raza, edad, vacunado, estado);
                    i++;
                }
            }
        }

        //FUNCION PARA MOSTRAR LOS PERROS Y ACTUALIZAR LA LISTA
        const mostrarPerros = () => {

            //CADA VEZ QUE ENTRA EN LA FUNCION SE RESETEA LA LISTA 
            mostradorDeNombresPerros = "LISTA DE PERROS:\n\n";
            mostradorDeDatosPerros = "LISTA DE PERROS:\n\n";
            mostradorDeEstado = "";
            perrosDisponibles = "\n\nLISTA DE PERROS DISPONIBLES PARA LA ADOPCIÓN: \n";
            perrosEnProceso = "LISTA DE PERROS EN PROCESO DE ADOPCIÓN:\n ";
            perrosAdoptados = "LISTA DE PERROS YA ADOPTADOS: \n\n";

            for (let i = 0; i <= perros.length - 1; i++) {
                mostradorDeDatosPerros = mostradorDeDatosPerros + "  " + perros[i].mostrarDatos() + "\n\n";
                mostradorDeNombresPerros = mostradorDeNombresPerros + "  " + perros[i].mostrarNombres() + "\n";
                perros[i].verificarEstado();
                mostradorDeEstado = `${perrosDisponibles} \n\n\n ${perrosEnProceso} \n\n\n ${perrosAdoptados} \n\n\n`;
            }
            console.log(mostradorDeDatosPerros + mostradorDeEstado);
            console.log(mostradorDeNombresPerros + mostradorDeEstado);

        }

        const confirmar = () => {
            let confirmar;
            do {
                let nombre = prompt("Nombre del perro:");
                let color = prompt("Color del perro:");
                let raza = prompt("Raza del perro:");
                let edad = parseInt(prompt("Edad del perro:"));
                //VERIFICAMOS QUE EL USUARIO NOS DE UN NUMERO
                while (isNaN(edad)) {
                    alert("Porfavor introdusca un numero valido");
                    edad = parseInt(prompt("Edad del perro:"));
                }
                let vacunado = confirm("¿Esta vacunado?");
                let estado = parseInt(prompt("Estados de adopción: \n 1)En adopción \n 2)Proceso de adopción \n 3)Adoptado "));
                //VERIFICAMOS QUE EL USUARIO NOS DE UN NUMERO
                while (isNaN(estado) || (estado != 1 && estado != 2 && estado != 3)) {
                    alert("Porfavor introdusca un numero valido");
                    estado = parseInt(prompt("Estados de adopción: \n 1)En adopción \n 2)Proceso de adopción \n 3)Adoptado "));
                }
                introducirPerro(nombre, color, raza, edad, vacunado, estado);
                confirmar = confirm("¿Crear otro perro?");
            } while (confirmar != false);
            //MOSTRAMOS TODO EN CONSOLA 
            mostrarPerros();
        }

        //FUNCION PARA LLAMAR AL CAMBIO DE ESTADO
        const cambiarEstado = () => {
            //LE PEDIMOS AL USUARIO EL NOMBRE DEL PERRO A MODIFICAR
            let perroAModificar = prompt("El estado de que perro desea modificar: ");
            for (let i = 0; i <= perros.length; i++) {
                if (perros[i].nombre == perroAModificar) {
                    //SI EL PERRO EXISTE EN EL ARRAY ENTONCES LE PEDIMOS QUE NOS DE UNA OPCION VALIDA PARA SU ESTADO
                    let modificador = parseInt(prompt(`El perro ${perros[i].nombre} cambiara del estado ${perros[i].estado} al... \n 1)En adopción \n 2)Proceso de adopción \n 3)Adoptado `));
                    while (isNaN(modificador) || (modificador != 1 && modificador != 2 && modificador != 3)) {
                        alert("Porfavor introdusca un numero valido");
                        modificador = parseInt(prompt(`El perro ${perros[i].nombre} cambiara del estado ${perros[i].estado} al... \n 1)En adopción \n 2)Proceso de adopción \n 3)Adoptado `));
                    }

                    //USAMOS EL METODO PARA MODIFICAR EL ESTADO Y SU AUXILIAR Y MOSTRAMOS EN CONSOLA
                    perros[i].modificarAdoptado(modificador);
                    perros[i].estado_aux = modificador;
                    mostrarPerros();
                    return false;

                }

            }

        }

        confirmar();


    </script>

</body>

</html>